require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_MACH_APIC_H)) {
    eval 'sub __ASM_MACH_APIC_H () {1;}' unless defined(&__ASM_MACH_APIC_H);
    require 'asm/smp.ph';
    eval 'sub SEQUENTIAL_APICID () {1;}' unless defined(&SEQUENTIAL_APICID);
    if(defined(&SEQUENTIAL_APICID)) {
	eval 'sub xapic_phys_to_log_apicid {
	    my($phys_apic) = @_;
    	    eval q(( (1 << (($phys_apic) & 0x3)) | (($phys_apic<<2) & (~0xf)) ));
	}' unless defined(&xapic_phys_to_log_apicid);
    }
 elsif((defined(&CLUSTERED_APICID) ? &CLUSTERED_APICID : 0)) {
	eval 'sub xapic_phys_to_log_apicid {
	    my($phys_apic) = @_;
    	    eval q(( (1 << (($phys_apic) & 0x3)) | (($phys_apic) & (~0xf)) ));
	}' unless defined(&xapic_phys_to_log_apicid);
    }
    eval 'sub NO_BALANCE_IRQ () {(1);}' unless defined(&NO_BALANCE_IRQ);
    eval 'sub esr_disable () {(1);}' unless defined(&esr_disable);
    eval 'sub NO_IOAPIC_CHECK () {(0);}' unless defined(&NO_IOAPIC_CHECK);
    eval 'sub apic_id_registered {
        my($void) = @_;
	    eval q({ (1); });
    }' unless defined(&apic_id_registered);
    eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_CLUSTER);}' unless defined(&APIC_DFR_VALUE);
    eval 'sub TARGET_CPUS () {( &target_cpus());}' unless defined(&TARGET_CPUS);
    eval 'sub INT_DELIVERY_MODE () { &dest_Fixed;}' unless defined(&INT_DELIVERY_MODE);
    eval 'sub INT_DEST_MODE () {1;}' unless defined(&INT_DEST_MODE);
    eval 'sub check_apicid_used {
        my($bitmap,$apicid) = @_;
	    eval q({ 0; });
    }' unless defined(&check_apicid_used);
    eval 'sub apicid_cluster {
        my($apicid) = @_;
	    eval q(($apicid & 0xf0));
    }' unless defined(&apicid_cluster);
    eval 'sub calculate_ldr {
        my($old) = @_;
	    eval q({ my $id;  $id =  &xapic_phys_to_log_apicid( &hard_smp_processor_id()); (($old & ~ &APIC_LDR_MASK) |  &SET_APIC_LOGICAL_ID( $id)); });
    }' unless defined(&calculate_ldr);
    eval 'sub clustered_apic_check {
        my($void) = @_;
	    eval q({  &printk(\\"Enabling APIC mode:  %s.  Using %d I/O APICs\\\\n\\", \\"Cluster\\",  &nr_ioapics); });
    }' unless defined(&clustered_apic_check);
    eval 'sub multi_timer_check {
        my($apic,$irq) = @_;
	    eval q({ 0; });
    }' unless defined(&multi_timer_check);
    eval 'sub apicid_to_node {
        my($logical_apicid) = @_;
	    eval q({ 0; });
    }' unless defined(&apicid_to_node);
    eval 'sub cpu_present_to_apicid {
        my($mps_cpu) = @_;
	    eval q({  &if ($mps_cpu <  &NR_CPUS)  $bios_cpu_apicid[$mps_cpu];  &else  &BAD_APICID; });
    }' unless defined(&cpu_present_to_apicid);
    eval 'sub apicid_to_cpu_present {
        my($phys_apicid) = @_;
	    eval q({  &physid_mask_of_physid($phys_apicid); });
    }' unless defined(&apicid_to_cpu_present);
    eval 'sub mpc_apic_id {
        my($m,$translation_record) = @_;
	    eval q({  &printk(\\"Processor #%d %ld:%ld APIC version %d\\\\n\\",  ($m->{mpc_apicid}), ( ($m->{mpc_cpufeature}) &  &CPU_FAMILY_MASK) >> 8, ( ($m->{mpc_cpufeature}) &  &CPU_MODEL_MASK) >> 4,  ($m->{mpc_apicver}));  ($m->{mpc_apicid}); });
    }' unless defined(&mpc_apic_id);
    eval 'sub ioapic_phys_id_map {
        my($phys_map) = @_;
	    eval q({  &physids_promote(0xf); });
    }' unless defined(&ioapic_phys_id_map);
    eval 'sub WAKE_SECONDARY_VIA_INIT () {1;}' unless defined(&WAKE_SECONDARY_VIA_INIT);
    eval 'sub setup_portio_remap {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&setup_portio_remap);
    eval 'sub enable_apic_mode {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&enable_apic_mode);
    eval 'sub check_phys_apicid_present {
        my($boot_cpu_physical_apicid) = @_;
	    eval q({ (1); });
    }' unless defined(&check_phys_apicid_present);
    eval 'sub phys_pkg_id {
        my($cpuid_apic,$index_msb) = @_;
	    eval q({ $cpuid_apic >> $index_msb; });
    }' unless defined(&phys_pkg_id);
}
1;
