require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MTD_XIP_H__)) {
    eval 'sub __LINUX_MTD_XIP_H__ () {1;}' unless defined(&__LINUX_MTD_XIP_H__);
    require 'linux/config.ph';
    if(defined(&CONFIG_MTD_XIP)) {
	eval 'sub __xipram () { &__attribute__ (( &__section__ (".data")));}' unless defined(&__xipram);
	require 'linux/compiler.ph';
	if(defined( &CONFIG_ARCH_SA1100) || defined( &CONFIG_ARCH_PXA)) {
	    require 'asm/hardware.ph';
	    if(defined(&CONFIG_ARCH_PXA)) {
		require 'asm/arch/pxa-regs.ph';
	    }
	    eval 'sub xip_irqpending () {
	        eval q(( &ICIP &  &ICMR));
	    }' unless defined(&xip_irqpending);
	    eval 'sub xip_currtime () {
	        eval q(( &OSCR));
	    }' unless defined(&xip_currtime);
	    eval 'sub xip_elapsed_since {
	        my($x) = @_;
    		eval q((( &OSCR - ($x)) / 4));
	    }' unless defined(&xip_elapsed_since);
	} else {
	    warn("\"missing\ IRQ\ and\ timer\ primitives\ for\ XIP\ MTD\ support\"");
	    warn("\"some\ of\ the\ XIP\ MTD\ support\ code\ will\ be\ disabled\"");
	    warn("\"your\ system\ will\ therefore\ be\ unresponsive\ when\ writing\ or\ erasing\ flash\"");
	    eval 'sub xip_irqpending () {
	        eval q((0));
	    }' unless defined(&xip_irqpending);
	    eval 'sub xip_currtime () {
	        eval q((0));
	    }' unless defined(&xip_currtime);
	    eval 'sub xip_elapsed_since {
	        my($x) = @_;
    		eval q((0));
	    }' unless defined(&xip_elapsed_since);
	}
	if(defined( &CONFIG_CPU_XSCALE)) {
	    eval 'sub xip_cpu_idle () {
	        eval q( &asm  &volatile (\\"mcr p14, 0, %0, c7, c0, 0\\" :: \\"r\\" (1)));
	    }' unless defined(&xip_cpu_idle);
	} else {
	    eval 'sub xip_cpu_idle () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&xip_cpu_idle);
	}
    } else {
	eval 'sub __xipram () {1;}' unless defined(&__xipram);
    }
}
1;
